t1 = Thread.new { sleep 100 }
t2 = Thread.new do
  if Thread.current == Thread.main
    puts "This is the main thread."   # Does NOT print
  end
  1.upto(1000)
    sleep 0.1
  end
end

count = Thread.list.size              # 3
if Thread.list.include?(Thread.main)
  puts "Main thread is alive."        # Always prints!
end
if Thread.current == Thread.main
  puts "I'm the main thread."         # Prints here...
end
