require "tk"

def packing(padx, pady, side, anchor=nil)
  side = :left if not side
  anchor = :n if anchor == nil
  { "padx" => padx, "pady" => pady,
    "side" => side.to_s, "anchor" => anchor.to_s  }
end

root = TkRoot.new() { title "Telnet session" }
top = TkFrame.new(root) 
fr1   = TkFrame.new(top)
fr1a  = TkFrame.new(fr1)
fr1b  = TkFrame.new(fr1)
fr2   = TkFrame.new(top)
fr3   = TkFrame.new(top)
fr4   = TkFrame.new(top)

$labelPack  = packing(5, 5, :top, :w)
$entryPack  = packing(5, 2, :top)
$buttonPack = packing(15, 5, :left, :center)
framePack   = packing(2, 2, :top)
frame1Pack  = packing(2, 2, :left)

$varHost = TkVariable.new
$varPort = TkVariable.new
$varUser = TkVariable.new
$varPass = TkVariable.new

labHost = TkLabel.new(fr1a) do
  text "Host name"
  pack $labelPack
end
entHost = TkEntry.new(fr1a) do
  textvariable $varHost
  font "{Arial} 10"
  pack $entryPack
end

labPort = TkLabel.new(fr1b) do
  text "Port"
  pack $labelPack
end
entPort = TkEntry.new(fr1b) do
  width 4
  textvariable $varPort
  font "{Arial} 10"
  pack $entryPack
end

labUser = TkLabel.new(fr2) do
  text "User name"
  pack $labelPack
end
entUser = TkEntry.new(fr2) do
  width 21
  font "{Arial} 12"
  textvariable $varUser
  pack $entryPack
end

labPass = TkLabel.new(fr3) do
  text "Password"
  pack $labelPack
end
entPass = TkEntry.new(fr3) do
  width 21
  show "*"
  textvariable $varPass
  font "{Arial} 12"
  pack $entryPack
end

btnSignon = TkButton.new(fr4) do
  text "Sign on"
  command proc {}         # Does nothing!
  pack $buttonPack
end
btnCancel = TkButton.new(fr4) do
  text "Cancel"
  command proc { exit }   # Just exits
  pack $buttonPack
end

top.pack framePack
fr1.pack framePack
fr2.pack framePack
fr3.pack framePack
fr4.pack framePack
fr1a.pack frame1Pack
fr1b.pack frame1Pack

$varHost.value = "samspublishing.com"
$varUser.value = "william"
$varPort.value = 23

entPass.focus

foo = entUser.font

Tk.mainloop
