require "shell"

sh1 = Shell.new             # Work in the current directory
sh2 = Shell.cd("/tmp/hal")  # Work in /tmp/hal

sh = Shell.new

# Print the motd file to stdout
sh.cat("/etc/motd") > STDOUT

# Print it again
(sh.cat < "/etc/motd") > STDOUT
(sh.echo "This is a test") > "myfile.txt"

# Append a line to /etc/motd
sh.echo("Hello, world!") >> "/etc/motd"

# Cat two files to stdout, tee-ing to a third
(sh.cat "file1" "file2") | (tee "file3") > STDOUT
