#!/usr/bin/ksh

# Let ksh find the difference in seconds 
# between two dates using Ruby...

export time1="2001-04-02 15:56:12"
export time2="2001-12-08 12:03:19"

cat <<EOF | ruby | read elapsed
require "parsedate"

time1 = ENV["time1"]
time2 = ENV["time2"]

args1 = ParseDate.parsedate(time1)
args2 = ParseDate.parsedate(time2)

args1 = args1[0..5]
args2 = args2[0..5]

t1 = Time.local(*args1)
t2 = Time.local(*args2)

diff = t2 - t1
puts diff
EOF

echo "Elapsed seconds = " $elapsed
